#pragma once

#include <ardix/types.h>

#include <toolchain.h>

static __always_inline word_t _atomic_enter(void)
{
	word_t primask;
	__asm__ volatile(
	"	mrs	%0, primask	\n"
	"	cpsid	i		\n"
	: "=r"(primask));
	return primask;
}

static __always_inline void _atomic_restore(word_t context)
{
	if (!(context & 1))
		__asm__ volatile("cpsie i");
}

static inline int _is_atomic(void)
{
	int primask;
	__asm__ volatile("mrs %0, primask" : "=r"(primask));
	return primask & 1;
}
